#include "stdafx.h"
#include "NeMessenger.h"
#include "ConfigMemo.h"
#include "CommonFunction.h"
#include "ReceivedNoteManager.h"


IMPLEMENT_DYNAMIC(CConfigMemo, CConfigBaseDlg)

CConfigMemo::CConfigMemo(CWnd* pParent /*=NULL*/)
: CConfigBaseDlg(CConfigMemo::IDD, pParent)
{
	m_nMemoAlarmType = 0;
	m_nChatMode = 0;

	m_rcNoteTitleText.SetRect(20,27,108,48);
	m_rcChatModeTitleText.SetRect(20,140,108,170);
	m_rcCopyTitleText.SetRect(20,200,108, 233);
	m_rcNoteCloseTitleText.SetRect(20, 234, 108, 270);


	m_rcAlramDefalutText.SetRect(134,28,360,45);
	m_rcAlramViewText.SetRect(134,53,360,71);
	m_rcAlramTaskBarText.SetRect(134,79,360,97);
	m_rcAlramRejectText.SetRect(134,105,360,123);

	m_rcChatModeBubbleText.SetRect(134,140,360,163);
	m_rcChatModePlainText.SetRect(134,165,360,187);
	m_rcCopyText.SetRect(134,201,360,222);
	m_rcNoteCloseText.SetRect(134,235,360,274);
	
}

CConfigMemo::~CConfigMemo()
{
}

void CConfigMemo::DoDataExchange(CDataExchange* pDX)
{
	CConfigBaseDlg::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_MEMO_ALARM_RADIO, m_rdAlramDefault);
	DDX_Control(pDX, IDC_MEMO_VIEW_RADIO, m_rdAlarmView);
	DDX_Control(pDX, IDC_MEMO_TASKBAR_RADIO, m_rdAlarmTaskBar);
	DDX_Control(pDX, IDC_MEMO_NOALARM_RADIO, m_rdAlarmReject);
	DDX_Radio(pDX, IDC_MEMO_ALARM_RADIO, m_nMemoAlarmType);
	DDX_Control(pDX, IDC_COPY_AUTO_NAME_CHECK, m_chkCopyNameDate);
	DDX_Control(pDX, IDC_CHECK_NOTE_CLOSE, m_chkNoteClose);
	DDX_Control(pDX, IDC_RADIO_CHAT_BUBBLE, m_rdChatBubble);
	DDX_Control(pDX, IDC_RADIO_CHAT_PLAIN, m_rdChatPlain);
	DDX_Radio(pDX, IDC_RADIO_CHAT_BUBBLE, m_nChatMode);
	DDX_Control(pDX, IDC_CHECK_NOTE_RECOVERY, m_chkNoteRecovery);
}

BEGIN_MESSAGE_MAP(CConfigMemo, CConfigBaseDlg)
	ON_WM_ERASEBKGND()
	ON_BN_CLICKED(IDC_RADIO_CHAT_BUBBLE, &CConfigMemo::OnBnClickedRadioChatBubble)
	ON_BN_CLICKED(IDC_RADIO_CHAT_PLAIN, &CConfigMemo::OnBnClickedRadioChatPlain)
END_MESSAGE_MAP()

BOOL CConfigMemo::OnInitDialog()
{
	CConfigBaseDlg::OnInitDialog();	

	//  
	GetDlgItem(IDC_MEMO_ALARM_RADIO)->MoveWindow(118,31,11,11,TRUE);
	GetDlgItem(IDC_MEMO_VIEW_RADIO)->MoveWindow(118,56,11,11,TRUE);
	GetDlgItem(IDC_MEMO_TASKBAR_RADIO)->MoveWindow(118,81,11,11,TRUE);
	GetDlgItem(IDC_MEMO_NOALARM_RADIO)->MoveWindow(118,106,11,11,TRUE);


	// ȭ 
	m_rdChatBubble.MoveWindow(118,143,11,11,TRUE);
	m_rdChatPlain.MoveWindow(118,168,11,11,TRUE);
	// ȭ 
	m_chkCopyNameDate.MoveWindow(118,202,11,11,TRUE);
	m_chkCopyNameDate.SetBitmapFile(GetAppImgFile(_T("checkbox.bmp")),RGB(0,0,0));

	//  
	m_chkNoteClose.MoveWindow(118,237,11,11,TRUE);
	m_chkNoteClose.SetBitmapFile(GetAppImgFile(_T("checkbox.bmp")),RGB(0,0,0));


	//
	m_chkNoteRecovery.ShowWindow(SW_HIDE);
	

	AddClickAssociateInfo(&m_rdAlramDefault, m_rcAlramDefalutText);
	AddClickAssociateInfo(&m_rdAlarmTaskBar, m_rcAlramTaskBarText);
	AddClickAssociateInfo(&m_rdAlarmView, m_rcAlramViewText);
	AddClickAssociateInfo(&m_rdAlarmReject, m_rcAlramRejectText);
	AddClickAssociateInfo(&m_rdChatBubble, m_rcChatModeBubbleText);
	AddClickAssociateInfo(&m_rdChatPlain, m_rcChatModePlainText);

	AddClickAssociateInfo(&m_chkCopyNameDate, m_rcCopyText);
	AddClickAssociateInfo(&m_chkNoteClose, m_rcNoteCloseText);
	//AddClickAssociateInfo(&m_chkNoteRecovery, )
	InitData();		

	return TRUE;
}

BOOL CConfigMemo::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_ESCAPE)
		{
			return TRUE;
		}
		else if (pMsg->wParam == VK_RETURN)
		{			
			return TRUE;
		}
	}
	else if (pMsg->message == WM_CLOSE)
	{
		OnOK();
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}

void CConfigMemo::InitData()
{
	m_nMemoAlarmType = GET_CONFIG()->GetMemoAlarmType();
	m_nChatMode = GET_CONFIG()->GetChatDisplayType();

	int nVlaue = GET_CONFIG()->GetCopyNameDate();
	DDX_CHECKBOX_VALUE(m_chkCopyNameDate, nVlaue, FALSE);

	if (m_nChatMode == CHAT_BUBBLE)
	{
		m_chkCopyNameDate.ShowWindow(SW_SHOW);
	}
	else
	{
		m_chkCopyNameDate.ShowWindow(SW_HIDE);
	}

	nVlaue = GET_CONFIG()->GetNoteCloseType();
	DDX_CHECKBOX_VALUE(m_chkNoteClose, nVlaue, FALSE);

	nVlaue = GET_CONFIG()->GetNoteRecoveryType();
	DDX_CHECKBOX_VALUE(m_chkNoteRecovery, nVlaue , FALSE);
	
	UpdateData(FALSE);
}

void CConfigMemo::DoApply()
{
	UpdateData(TRUE);

	GET_CONFIG()->SetMemoAlarmType(m_nMemoAlarmType);
	GET_CONFIG()->SetChatDisplayType(m_nChatMode);

	int nValue = 0;
	DDX_CHECKBOX_VALUE(m_chkCopyNameDate, nValue, TRUE);
	GET_CONFIG()->SetCopyNameDate(nValue);

	DDX_CHECKBOX_VALUE(m_chkNoteClose, nValue, TRUE);
	GET_CONFIG()->SetNoteCloseType(nValue);

	DDX_CHECKBOX_VALUE(m_chkNoteRecovery, nValue, TRUE);
	GET_CONFIG()->SetNoteRecoveryType(nValue);
	if (GET_CONFIG()->GetNoteRecoveryType())
	{
		GET_APP()->m_pReceivedNoteManager->InsertAllRecvNoteToSqlite();
	}
	else
	{
		GET_APP()->m_pReceivedNoteManager->DeleteAllRecvNoteFromSqlite();
	}


	GET_APP()->m_pChatDialogManager->InvalidateChatDlg();

	
}

BOOL CConfigMemo::OnEraseBkgnd(CDC* pDC)
{
	BOOL bRet = CConfigBaseDlg::OnEraseBkgnd(pDC);

	CFont *pOldFont = pDC->SelectObject(&g_ftDefault10PT);
	COLORREF oldColor = pDC->SetTextColor(CONFIGMEMO_TITLE_TEXT_COLOR);
	
	CRect rtClient(0, 0, 0, 0);
	GetClientRect(rtClient);
	pDC->FillSolidRect(rtClient, RGB(255,255,255));
	pDC->SetBkMode(TRANSPARENT);

	pDC->DrawText(LoadStringFromResource(IDS_STRING417),m_rcNoteTitleText,DT_LEFT);			//  
	pDC->DrawText(LoadStringFromResource(IDS_STRING573),m_rcChatModeTitleText,DT_LEFT);		// ȭ 

	if (m_chkCopyNameDate.IsWindowVisible())
		pDC->DrawText(LoadStringFromResource(IDS_STRING345),m_rcCopyTitleText,DT_LEFT);			// ȭ 

	pDC->DrawText(LoadStringFromResource(IDS_STRING453), m_rcNoteCloseTitleText, DT_LEFT);	//  


	pDC->SelectObject(&g_ftDefault9PT);
	pDC->SetTextColor(CONFIGMEMO_BASIC_TEXT_COLOR);

	pDC->DrawText(LoadStringFromResource(IDS_STRING419),m_rcAlramDefalutText,DT_LEFT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING420),m_rcAlramViewText,DT_LEFT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING421),m_rcAlramTaskBarText,DT_LEFT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING422),m_rcAlramRejectText,DT_LEFT);
	
	pDC->DrawText(LoadStringFromResource(IDS_STRING390), m_rcChatModeBubbleText, DT_LEFT);
	pDC->DrawText(LoadStringFromResource(IDS_STRING391), m_rcChatModePlainText, DT_LEFT);

	if (m_chkCopyNameDate.IsWindowVisible())
		pDC->DrawText(LoadStringFromResource(IDS_STRING575), m_rcCopyText, DT_LEFT);

	pDC->DrawText(LoadStringFromResource(IDS_STRING576), m_rcNoteCloseText, DT_LEFT);

	pDC->SetTextColor(oldColor);	
	pDC->SelectObject(pOldFont);

	return bRet;
}

void CConfigMemo::OnBnClickedRadioChatBubble()
{
	m_chkCopyNameDate.ShowWindow(SW_SHOW);
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
	//NMessageBox(this, LoadStringFromResource(IDS_STRING578));
}

void CConfigMemo::OnBnClickedRadioChatPlain()
{
	m_chkCopyNameDate.ShowWindow(SW_HIDE);
	RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
	//NMessageBox(this, LoadStringFromResource(IDS_STRING578));
}
